diff --git a/public/build/assets/mapValues-DX5e7Edw.js b/public/build/assets/mapValues-CaqZHD-c.js
similarity index 71%
rename from public/build/assets/mapValues-DX5e7Edw.js
rename to public/build/assets/mapValues-CaqZHD-c.js
index 3ab6a4b..513176a 100644
--- a/public/build/assets/mapValues-DX5e7Edw.js
+++ b/public/build/assets/mapValues-CaqZHD-c.js
@@ -1 +1 @@
-import{y as i}from"./app-DgprvZit.js";import{m as v,l as b,_ as f}from"./_baseAssignValue-ByPtvlfg.js";function m(r){return function(a,e,t){for(var s=-1,n=Object(a),o=t(a),u=o.length;u--;){var l=o[r?u:++s];if(e(n[l],l,n)===!1)break}return a}}var F=m,p=F,_=p(),c=_,g=c,V=v;function w(r,a){return r&&g(r,a,V)}var O=w,$=f,h=O,x=b;function B(r,a){var e={};return a=x(a),h(r,function(t,s,n){$(e,s,a(t,s,n))}),e}var A=B;const k=i(A);export{k as m};
+import{u as i}from"./app-3ePTDV-1.js";import{m as v,l as b,_ as f}from"./_baseAssignValue-CET8T8Rz.js";function m(r){return function(a,e,t){for(var s=-1,n=Object(a),o=t(a),u=o.length;u--;){var l=o[r?u:++s];if(e(n[l],l,n)===!1)break}return a}}var F=m,p=F,_=p(),c=_,g=c,V=v;function w(r,a){return r&&g(r,a,V)}var O=w,$=f,h=O,x=b;function B(r,a){var e={};return a=x(a),h(r,function(t,s,n){$(e,s,a(t,s,n))}),e}var A=B;const k=i(A);export{k as m};
diff --git a/ready_for_envato.sh b/ready_for_envato.sh
index 527c1b9..52c0ad8 100755
--- a/ready_for_envato.sh
+++ b/ready_for_envato.sh
@@ -42,10 +42,8 @@ Hi,
 
 I’ve just updated some features as part of the following release:
 
---- v1.5.6  (16 Jul 2025) ---
-✅ Improvement: Security Updates
-✅ Improvement: Laravel System Updates
-
+--- v1.5.5  (28 Jun 2025) ---
+✅ Improvement: Labels are now project-specific. A project’s labels will no longer appear under tasks belonging to other projects.
 
 Please publish the latest script from main-files.zip to the live environment.
 
diff --git a/resources/js/Components/NotificationBell.vue b/resources/js/Components/NotificationBell.vue
new file mode 100644
index 0000000..155b04b
--- /dev/null
+++ b/resources/js/Components/NotificationBell.vue
@@ -0,0 +1,93 @@
+<script setup>
+import { ref, computed, onMounted, watch } from 'vue';
+import { usePage, router, Link } from '@inertiajs/vue3';
+
+const page = usePage();
+const isOpen = ref(false);
+
+const notifications = ref(page.props.auth.notifications || []);
+const unreadCount = ref(page.props.auth.unread_count || 0);
+const user = computed(() => page.props.auth.user);
+
+const formatTimeAgo = (dateString) => {
+    const date = new Date(dateString);
+    const seconds = Math.floor((new Date() - date) / 1000);
+    let interval = seconds / 31536000;
+    if (interval > 1) return Math.floor(interval) + " years ago";
+    interval = seconds / 2592000;
+    if (interval > 1) return Math.floor(interval) + " months ago";
+    interval = seconds / 86400;
+    if (interval > 1) return Math.floor(interval) + " days ago";
+    interval = seconds / 3600;
+    if (interval > 1) return Math.floor(interval) + " hours ago";
+    interval = seconds / 60;
+    if (interval > 1) return Math.floor(interval) + " minutes ago";
+    return Math.floor(seconds) + " seconds ago";
+};
+
+// Mark all as read when dropdown is opened
+watch(isOpen, (isNowOpen) => {
+    if (isNowOpen && unreadCount.value > 0) {
+        // Optimistically update UI
+        notifications.value.forEach(n => n.read_at = new Date().toISOString());
+        unreadCount.value = 0;
+
+        // Fire request in the background
+        router.post(route('notifications.markAllAsRead'), {}, {
+            preserveScroll: true,
+        });
+    }
+});
+
+// Listen for new notifications in real-time
+onMounted(() => {
+    if (user.value) {
+        window.Echo.private(`App.Models.User.${user.value.id}`)
+            .notification((notification) => {
+                notifications.value.unshift(notification);
+                unreadCount.value++;
+            });
+    }
+});
+</script>
+
+<template>
+    <div class="relative">
+        <button @click="isOpen = !isOpen" class="relative text-gray-500 hover:text-gray-700 focus:outline-none">
+            <!-- Bell Icon -->
+            <svg class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
+                <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 17h5l-1.405-1.405A2.032 2.032 0 0118 14.158V11a6.002 6.002 0 00-4-5.659V5a2 2 0 10-4 0v.341C7.67 6.165 6 8.388 6 11v3.159c0 .538-.214 1.055-.595 1.436L4 17h5m6 0v1a3 3 0 11-6 0v-1m6 0H9" />
+            </svg>
+            <!-- Unread Badge -->
+            <span v-if="unreadCount > 0" class="absolute -top-1 -right-1 flex h-4 w-4">
+                <span class="animate-ping absolute inline-flex h-full w-full rounded-full bg-red-400 opacity-75"></span>
+                <span class="relative inline-flex rounded-full h-4 w-4 bg-red-500 items-center justify-center text-xs text-white">{{ unreadCount }}</span>
+            </span>
+        </button>
+
+        <!-- Dropdown Panel -->
+        <div v-if="isOpen" @click.away="isOpen = false" class="absolute right-0 mt-2 w-80 rounded-md shadow-lg bg-white ring-1 ring-black ring-opacity-5 z-50">
+            <div class="flex justify-between items-center p-3 border-b">
+                <h3 class="font-semibold text-gray-700">Notifications</h3>
+            </div>
+            <div v-if="notifications.length > 0" class="max-h-96 overflow-y-auto">
+                <Link v-for="n in notifications" :key="n.id || n.task_id" :href="n.data?.url || '#'" @click="isOpen = false"
+                      :class="['block w-full text-left p-3 border-b hover:bg-gray-100', { 'bg-sky-50': !n.read_at }]">
+                    <p class="text-sm text-gray-800">
+                        <strong>{{ n.data?.action_user_name || n.action_user_name }}</strong>
+                        {{ n.data?.message || n.message }}
+                    </p>
+                    <p class="text-xs text-gray-500 mt-1">{{ formatTimeAgo(n.created_at) }}</p>
+                </Link>
+            </div>
+            <div v-else class="p-4 text-center text-sm text-gray-500">
+                You're all caught up!
+            </div>
+            <div class="p-2 border-t text-center bg-gray-50">
+                <Link :href="route('notifications.index')" @click="isOpen = false" class="text-sm font-medium text-blue-600 hover:text-blue-800">
+                    View All Notifications
+                </Link>
+            </div>
+        </div>
+    </div>
+</template>
diff --git a/resources/js/Pages/Notifications/Index.vue b/resources/js/Pages/Notifications/Index.vue
new file mode 100644
index 0000000..db09c34
--- /dev/null
+++ b/resources/js/Pages/Notifications/Index.vue
@@ -0,0 +1,99 @@
+<script setup>
+import Layout from '@/Shared/Layout.vue';
+import Pagination from '@/Components/Pagination.vue'; // We'll create this bonus component
+import { Head, Link, router } from '@inertiajs/vue3';
+
+// The 'notifications' prop is a paginated object from Laravel
+defineProps({
+    notifications: Object,
+});
+
+// A helper function to make timestamps user-friendly
+const formatTimeAgo = (dateString) => {
+    if (!dateString) return '';
+    const date = new Date(dateString);
+    const seconds = Math.floor((new Date() - date) / 1000);
+    if (seconds < 60) return "just now";
+    let interval = seconds / 31536000;
+    if (interval > 1) return Math.floor(interval) + " years ago";
+    interval = seconds / 2592000;
+    if (interval > 1) return Math.floor(interval) + " months ago";
+    interval = seconds / 86400;
+    if (interval > 1) return Math.floor(interval) + " days ago";
+    interval = seconds / 3600;
+    if (interval > 1) return Math.floor(interval) + " hours ago";
+    interval = seconds / 60;
+    if (interval > 1) return Math.floor(interval) + " minutes ago";
+    return Math.floor(seconds) + " seconds ago";
+};
+
+// Function to trigger the 'mark all as read' route
+const markAllAsRead = () => {
+    router.post(route('notifications.markAllAsRead'), {}, {
+        preserveScroll: true, // Keep the user's scroll position
+    });
+};
+</script>
+
+<template>
+    <Head title="My Notifications" />
+
+    <Layout>
+        <template #header>
+            <div class="flex justify-between items-center">
+                <h2 class="font-semibold text-xl text-gray-800 leading-tight">
+                    Notification History
+                </h2>
+                <button
+                    @click="markAllAsRead"
+                    class="px-4 py-2 bg-blue-600 text-white text-sm font-medium rounded-md hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500"
+                >
+                    Mark All as Read
+                </button>
+            </div>
+        </template>
+
+        <div class="py-12">
+            <div class="max-w-4xl mx-auto sm:px-6 lg:px-8">
+                <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
+                    <ul class="divide-y divide-gray-200">
+                        <!-- Loop through the paginated data -->
+                        <li v-for="notification in notifications.data" :key="notification.id">
+                            <Link :href="notification.data.url" class="block p-4 sm:p-6 hover:bg-gray-50 transition duration-150 ease-in-out">
+                                <div class="flex items-center space-x-4">
+                                    <!-- Unread Indicator -->
+                                    <div class="flex-shrink-0">
+                                        <span v-if="!notification.read_at" class="h-2.5 w-2.5 rounded-full bg-blue-500" aria-hidden="true"></span>
+                                        <span v-else class="h-2.5 w-2.5 rounded-full bg-gray-300" aria-hidden="true"></span>
+                                    </div>
+
+                                    <!-- Notification Content -->
+                                    <div class="flex-1 min-w-0">
+                                        <p class="text-sm text-gray-800">
+                                            <strong class="font-semibold">{{ notification.data.action_user_name }}</strong>
+                                            {{ notification.data.message }} on task
+                                            <strong class="font-semibold">"{{ notification.data.task_title }}"</strong>.
+                                        </p>
+                                        <p class="text-sm text-gray-500 mt-1">
+                                            {{ formatTimeAgo(notification.created_at) }}
+                                        </p>
+                                    </div>
+                                </div>
+                            </Link>
+                        </li>
+
+                        <!-- Empty State -->
+                        <li v-if="notifications.data.length === 0">
+                            <p class="text-center text-gray-500 py-10 px-6">
+                                You have no notifications in the last 30 days.
+                            </p>
+                        </li>
+                    </ul>
+
+                    <!-- Pagination Links -->
+                    <Pagination v-if="notifications.data.length > 0" :links="notifications.links" class="p-4" />
+                </div>
+            </div>
+        </div>
+    </Layout>
+</template>
diff --git a/resources/js/Pages/Settings/Notification.vue b/resources/js/Pages/Settings/Notification.vue
new file mode 100644
index 0000000..dbc9dfa
--- /dev/null
+++ b/resources/js/Pages/Settings/Notification.vue
@@ -0,0 +1,101 @@
+<script setup>
+import { router, Head, usePage, useForm } from '@inertiajs/vue3';
+import Layout from '@/Shared/Layout.vue';
+import { computed } from 'vue';
+
+// Get the settings directly from Inertia's props
+const props = defineProps({
+    settings: Array,
+});
+
+const settingForm = useForm({
+    is_active: props.setting.is_active,
+    email_is_active: props.setting.email_is_active,
+});
+
+function updateSetting() {
+    // settingForm.patch(route('...'), { preserveScroll: true });
+}
+
+// A computed property to watch for success messages from the backend
+const successMessage = computed(() => usePage().props.flash?.success);
+
+// Function to handle the toggle change using Inertia's router
+const updateSetting = (setting, field) => {
+    const newValue = !setting[field];
+
+    router.patch(route('admin.notification-settings.update', setting.id), {
+        [field]: newValue,
+    }, {
+        preserveScroll: true, // Keep the user's scroll position
+        onSuccess: () => {
+            // Optional: Show a success toast. The 'successMessage' computed prop will also update.
+        },
+        onError: (errors) => {
+            // Handle validation errors from the backend
+            alert(Object.values(errors).join(', '));
+        }
+    });
+};
+</script>
+
+<template>
+    <Head title="Notification Manager" />
+
+    <Layout>
+        <template #header>
+            <h2 class="font-semibold text-xl text-gray-800 leading-tight">
+                Notification Manager
+            </h2>
+        </template>
+
+        <div class="py-12">
+            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
+                <!-- Success message banner -->
+                <div v-if="successMessage" class="mb-4 bg-green-100 border border-green-400 text-green-700 px-4 py-3 rounded relative" role="alert">
+                    <span class="block sm:inline">{{ successMessage }}</span>
+                </div>
+
+                <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
+                    <div class="p-6 bg-white border-b border-gray-200">
+                        <div class="divide-y divide-gray-200">
+                            <!-- Header Row -->
+                            <div class="grid grid-cols-3 gap-4 font-bold p-4">
+                                <div class="col-span-1">Notification Type</div>
+                                <div class="text-center">In-App Active</div>
+                                <div class="text-center">Email Active</div>
+                            </div>
+
+                            <!-- Settings Rows (props.settings are automatically kept up-to-date by Inertia) -->
+                            <div v-for="setting in props.settings" :key="setting.id" class="grid grid-cols-3 gap-4 items-center p-4 hover:bg-gray-50">
+                                <!-- Notification Name and Description -->
+                                <div class="col-span-1">
+                                    <p class="font-medium text-gray-900">{{ setting.name }}</p>
+                                    <p class="text-sm text-gray-500">{{ setting.description }}</p>
+                                </div>
+
+                                <!-- In-App Toggle -->
+                                <div class="flex justify-center">
+                                    <button @click="updateSetting(setting, 'is_active')"
+                                            :class="[setting.is_active ? 'bg-blue-600' : 'bg-gray-200', 'relative inline-flex flex-shrink-0 h-6 w-11 border-2 border-transparent rounded-full cursor-pointer transition-colors ease-in-out duration-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500']">
+                                        <span :class="[setting.is_active ? 'translate-x-5' : 'translate-x-0', 'pointer-events-none inline-block h-5 w-5 rounded-full bg-white shadow transform ring-0 transition ease-in-out duration-200']"></span>
+                                    </button>
+                                </div>
+
+                                <!-- Email Toggle -->
+                                <div class="flex justify-center">
+                                    <button v-if="setting.can_be_emailed"
+                                            @click="updateSetting(setting, 'email_is_active')"
+                                            :class="[setting.email_is_active ? 'bg-blue-600' : 'bg-gray-200', 'relative inline-flex flex-shrink-0 h-6 w-11 border-2 border-transparent rounded-full cursor-pointer transition-colors ease-in-out duration-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500']">
+                                        <span :class="[setting.email_is_active ? 'translate-x-5' : 'translate-x-0', 'pointer-events-none inline-block h-5 w-5 rounded-full bg-white shadow transform ring-0 transition ease-in-out duration-200']"></span>
+                                    </button>
+                                    <span v-else class="text-sm text-gray-400">Not available</span>
+                                </div>
+                            </div>
+                        </div>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </Layout>
+</template>
diff --git a/resources/js/bootstrap.js b/resources/js/bootstrap.js
index 5f1390b..b28975f 100644
--- a/resources/js/bootstrap.js
+++ b/resources/js/bootstrap.js
@@ -2,3 +2,15 @@ import axios from 'axios';
 window.axios = axios;
 
 window.axios.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest';
+
+import Echo from 'laravel-echo';
+
+import Pusher from 'pusher-js';
+window.Pusher = Pusher;
+
+window.Echo = new Echo({
+    broadcaster: 'pusher',
+    key: import.meta.env.VITE_PUSHER_APP_KEY,
+    cluster: import.meta.env.VITE_PUSHER_APP_CLUSTER ?? 'mt1',
+    forceTLS: true,
+});
diff --git a/routes/web.php b/routes/web.php
index 71e474b..9409a3a 100755
--- a/routes/web.php
+++ b/routes/web.php
@@ -18,6 +18,8 @@ use App\Http\Controllers\LabelsController;
 use App\Http\Controllers\LanguagesController;
 use App\Http\Controllers\ListsController;
 use App\Http\Controllers\MailController;
+use App\Http\Controllers\NotificationController;
+use App\Http\Controllers\NotificationSettingController;
 use App\Http\Controllers\PermissionsController;
 use App\Http\Controllers\ProjectsController;
 use App\Http\Controllers\ReportsController;
@@ -396,3 +398,17 @@ Route::get('/license/activate', [LicenseController::class, 'showActivationForm']
 Route::post('/license/activate', [LicenseController::class, 'activate'])->name('license.activate');
 
 
+
+
+
+Route::middleware(['auth'])->prefix('admin')->name('admin.')->group(function () {
+        Route::get('/notification-settings', [NotificationSettingController::class, 'index'])->name('notification-settings.index');
+        Route::patch('/notification-settings/{setting}', [NotificationSettingController::class, 'update'])->name('notification-settings.update');
+    });
+
+
+Route::middleware(['auth', 'verified'])->group(function () {
+    Route::get('/notifications', [NotificationController::class, 'index'])->name('notifications.index');
+    Route::patch('/notifications/{notification}', [NotificationController::class, 'update'])->name('notifications.update');
+    Route::post('/notifications/mark-all-as-read', [NotificationController::class, 'markAllAsRead'])->name('notifications.markAllAsRead');
+});
diff --git a/tests/Feature/NewCommentNotificationTest.php b/tests/Feature/NewCommentNotificationTest.php
new file mode 100644
index 0000000..25da00a
--- /dev/null
+++ b/tests/Feature/NewCommentNotificationTest.php
@@ -0,0 +1,32 @@
+<?php
+
+use App\Models\Task;
+use App\Models\User;
+use App\Notifications\NewCommentNotification;
+use Illuminate\Support\Facades\Notification;
+use Tests\TestCase;
+
+class NewCommentNotificationTest extends TestCase
+{
+    public function test_assignees_are_notified_when_a_comment_is_added()
+    {
+        Notification::fake(); // Prevents actual notifications from being sent
+
+        $taskCreator = User::factory()->create();
+        $assignee = User::factory()->create();
+        $commenter = User::factory()->create();
+        $task = Task::factory()->create(['user_id' => $taskCreator->id]);
+        $task->assignees()->attach($assignee);
+
+        // Action: The commenter adds a comment
+//    $this->actingAs($commenter)->post(route('comments.store'), [
+//        'task_id' => $task->id,
+//        'details' => 'This is a test comment.',
+//    ]);
+
+        // Assertions
+        Notification::assertSentTo($assignee, NewCommentNotification::class);
+        Notification::assertNotSentTo($commenter, NewCommentNotification::class); // Don't notify yourself
+    }
+}
+
